********************************************************************************
* PROGRAM browse:                                                              *
*                                                                              *
* This is a sample BROWSE emulation program.                                   *
*                                                                              *
* It utilizes INKEY() values to form procedure names that can then be          *
* indescriminately called (as in a jump table).  These are the "key-handler"   *
* routines.  This is done in order to minimize key checking (i.e. DO CASE...). *
*                                                                              *
* It has been written to run under generic dbase environments but will         *
* take advantage of extensions when available.                                 *
*                                                                              *
* NOTE:   For debugging, It may be wise to comment out the ON ERROR and        *
*         SET ESCAPE OFF lines, as these will cause confusion.                 *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* VERSION: BR11B                                                               *
*                                                                              *
* UPDATED: 10/25/87  -  Fixed PgUp at last record bug.                         *
*                       Fixed fields > 80 char. bug.                           *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
*                                                                              *
********************************************************************************

* set up environment
SET TALK OFF
SET ESCAPE OFF
SET SAFETY OFF
SET EXACT ON
SET PROCEDURE TO browsep

DO checkdbf                                         && ensure database is open.
DO getndx

* initialize global variables
PUBLIC standard,enhanced,border,maxrows,maxcols,firstfield
PUBLIC startrow,toprec,lines,curcol,maxcol,finished,s_valid
PUBLIC s_help,WordTech,displine,highline,WT_v1_2,lastlines
*\WordTech = .t.
KEY = 0
nextfield  = 1
firstfield = 1
headrow  = 1
startrow = headrow+1
curcol = 1
s_valid = .F.
s_help =  .T.
finished = .T.
maxrows = 21
maxcols = 79
standard = "W/N"
enhanced = "N/W"
border   = "N"

CLEAR
DO config
DO heading
DO paintscr
DO highlite

ON ERROR ?? CHR(7)                                  && in case unsupported key

DO WHILE (KEY <> 27)                                && escape key not pressed:
  KEY = INKEY()                                     && |
  IF ( (KEY >= 48) .AND. (KEY <=122) )              && | alpha-numeric char ?
*   IF (WT_v1_2)                                    && |
*     KEYBOARD CHR(KEY )                            && | use this character
*     DO edit                                       && |
*   ELSE                                            && |
      ?? CHR(7)                                     && | sound bell
*   ENDIF                                           && |
  ELSE                                              && | control key:
    IF ( (KEY <> 27) .AND. (KEY <> 0) )             && | not escape key ?
      filename = 'key'+ SUBSTR(STR(KEY +1000,4),2)  && |
      do &filename                                  && | perform control key
    ENDIF                                           && |
  ENDIF                                             && |
ENDDO                                               && ------------------------
CLOSE PROCEDURE

* remove global variables
RELEASE standard,enhanced,border,maxrows,maxcols,firstfield
RELEASE startrow,toprec,lines,curcol,maxcol,finished,s_valid
RELEASE s_help,WordTech,displine,highline,WT_v1_2,lastlines
RELEASE ALL LIKE col*
RELEASE ALL LIKE len*
RELEASE ALL LIKE help*
RELEASE ALL LIKE dec*
RELEASE ALL LIKE type*
