********************************************************************************
* PROCEDURE config:                                                            *
*                                                                              *
* This routine sets up the global variables LENXXX,DECXXX,TYPEXXX,COLXXX       *
* and HELPXXX (when applicable) for the database in use.  These variables      *
* will be used later to format the screen.                                     *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE config
PRIVATE i,name,decname,lenname,typename,col,line
i = 1
len = 0
col = 2
lines = 1
PUBLIC col001
col001 = 1
COPY TO brtemp STRUCTURE EXTENDED
SELECT 10
USE brtemp
DO WHILE (.NOT. EOF() )
  lenname = "LEN" + SUBSTR(STR(i+1000,4),2)
  decname = "DEC" + SUBSTR(STR(i+1000,4),2)
  typename = "TYPE" + SUBSTR(STR(i+1000,4),2)
  PUBLIC &lenname,&decname,&typename
  &lenname = IIF(field_type = 'M',4,field_len)
  &typename = field_type
  &decname = field_dec
  len = len + MAX(field_len,LEN(RTRIM(field_name)))
  IF (len >= maxcols)
    name = "COL" + SUBSTR(STR(col+1000,4),2)
    PUBLIC &name
    &name = i
    len = field_len
    col = col + 1
  ENDIF
  i = i + 1
  SKIP
  IF (.NOT. EOF())
    len = len + 1
  ENDIF
ENDDO
maxcol = col -1
USE
SELECT 1
IF (s_help)
  DO inithelp
ENDIF
RETURN

********************************************************************************
* PROCEDURE inithelp:                                                          *
*                                                                              *
* This routine sets up the HELPXXX variables that will later be used           *
* for the HELP clause under environments that support this extension.          *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE inithelp
PRIVATE filename,newfile,name,i

filename = DBF()
DO stripfn WITH filename
newfile = UPPER(filename + ".DIC")
i = 1

IF (FILE(newfile))
  SELECT 10
  USE &newfile ALIAS DIC
  DO WHILE (.NOT. EOF())
    name = "HELP" + SUBSTR(STR(i+1000,4),2)
    PUBLIC &name
    &name = helptext
    i = i + 1
    SKIP
  ENDDO
  USE
ELSE
  s_help = .F.
ENDIF
SELECT 1
RETURN

********************************************************************************
* PROCEDURE heading:                                                           *
*                                                                              *
* This routine performs two tasks:                                             *
*                                                                              *
*   1) Prints the heading.                                                     *
*   2) Builds an expression string that will later be used to dynamically      *
*      format lines.                                                           *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE heading
PRIVATE i,len,decname,lenname,typelen,l

@ headrow,0 SAY ""
i = firstfield
displine = ""
highline = ""
len = 0
DO WHILE ( (FIELD(i) <> "") .AND. (len < maxcols) )
  fieldname = FIELD(i)
  lenname = "LEN" + SUBSTR(STR(i+1000,4),2)
  decname = "DEC" + SUBSTR(STR(i+1000,4),2)
  typename = "TYPE" + SUBSTR(STR(i+1000,4),2)
  len = len + MAX(&lenname,LEN(RTRIM(fieldname)))
  IF ( (len < maxcols) .OR. (i = firstfield) )
    IF (displine <> "")
      displine = displine + "+' '+"
      highline = highline + "+CHR(219)+"
    ENDIF
    DO CASE
      CASE &typename = 'C'
        displine = displine +  fieldname
        highline = highline +  fieldname
      CASE &typename = 'N'
        displine = displine +  "STR(" + fieldname + "," +STR(&lenname,2,0) + ","+STR(&decname,2,0) + ")"
        highline = highline +  "STR(" + fieldname + "," +STR(&lenname,2,0) + ","+STR(&decname,2,0) + ")"
      CASE &typename = 'D'
        displine = displine +  "DTOC(" + fieldname + ")"
        highline = highline +  "DTOC(" + fieldname + ")"
      CASE &typename = 'L'
        displine = displine +  "IIF(&fieldname,'T','F')"
        highline = highline +  "IIF(&fieldname,'T','F')"
      CASE &typename = 'M'
        displine = displine +  "IIF(EMPTY(&fieldname),'memo','MEMO')"
        highline = highline +  "IIF(EMPTY(&fieldname),'memo','MEMO')"
    ENDCASE
    ?? fieldname
    l = &lenname - LEN(fieldname)
    IF (l > 0)
      ?? REPLICATE('-',MIN(l,maxcols-LEN(fieldname)+1))
    ENDIF
    IF (l < 0)
      displine = displine + "+SPACE(" + STR(-l,2) + ")"
      highline = highline + "+REPL(CHR(219)," + STR(-l,2) + ")"
    ENDIF
  ENDIF
  i = i + 1
  IF (FIELD(i) <> "")
    ?? ' '
  ENDIF
ENDDO
@ ROW(),COL()
?
lastlines = lines
lines = INT(LEN(&displine)/(maxcols+1)) + 1
RETURN

********************************************************************************
* PROCEDURE paintscr:                                                          *
*                                                                              *
* This routine will paint the screen (less the heading) based on the           *
* variable "displine" previously built in the procedure "heading".             *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE paintscr
PRIVATE i,saverec,saverow,rowsused
IF (EOF())
  GO BOTTOM
ENDIF
i = 1
rowsused = 0
saverec = RECNO()
saverow = ROW()
@ startrow,0 SAY ""

toprec = RECNO()
DO WHILE ( i < (maxrows - lines + 1) )
  IF (EOF())
    @ ROW(),0
  ELSE
    rowsused = rowsused + lines
    ?? &displine
    @ ROW(),COL()
    SKIP
  ENDIF
  ?
  i = i + lines
ENDDO
@ ROW(),COL() CLEAR
GO saverec
IF (rowsused < saverow)
  @ startrow + rowsused - 1,0 SAY ""
ELSE
  @ saverow,0 SAY ""
ENDIF
RETURN

********************************************************************************
* PROCEDURE paintlin:                                                          *
*                                                                              *
* This routine will draw a formatted line at the current cursor position.      *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE paintlin
PRIVATE saverow
saverow = ROW()
?? &displine
@ ROW(),COL()
@ saverow,0 SAY ""
RETURN

********************************************************************************
* PROCEDURE edit:                                                              *
*                                                                              *
* This routine will edit the current line starting at the leftmost column.     *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE edit
PRIVATE i,saverow,helpname,name,len
saverow = ROW()
i = firstfield
line = ""
@ ROW(),0 SAY ""
row = ROW()
col = 0
len = 0
DO WHILE ((FIELD(i) <> "") .AND. (len < maxcols) )
  fieldname = FIELD(i)
  name = "LEN" + SUBSTR(STR(i+1000,4),2)
  len = len + MAX(&name,LEN(fieldname))
  IF ( (len < maxcols) .OR. (i = firstfield) )
    IF (s_help)
      helpname = "HELP" + SUBSTR(STR(i+1000,4),2)
      @ row,col GET &fieldname HELP RTRIM(&helpname)
    ELSE
      @ row,col GET &fieldname
    ENDIF
    i = i + 1
    col = COL()
    IF (FIELD(i) <> "" )
      col = col + MAX(LEN(fieldname) - &name,0) + 1
    ENDIF
  ENDIF
ENDDO
READ
@ saverow,0 SAY ""
IF (NDX(1) <> "")
  GO toprec
  DO paintscr
  SKIP ((saverow-lines)/lines) - 1 + (lines - 1)
ENDIF
DO key024                                           && move down one record
RETURN

********************************************************************************
* PROCEDURE highlite:                                                          *
*                                                                              *
* This routine will highlight (reverse videoize) the current line.             *
* This routine is typically invoked after the screen has been refreshed.       *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE highlite
@ ROW(),0 SAY ""
temp = &highline
@ ROW(),0 GET temp
CLEAR GETS
@ (ROW()-lines + 1),0 SAY ""
RETURN

********************************************************************************
*                                                                              *
* The keys follow...                                                           *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************

PROCEDURE key000         && no key
RETURN
PROCEDURE key001         && Home key
RETURN
PROCEDURE key002         && CTRL-right arrow
PRIVATE saverec,saverow

IF (curcol < maxcol)
  saverow = ROW()
  saverec = RECNO()
  name = "COL" + SUBSTR(STR(curcol+1000+1,4),2)
  firstfield = &name
  curcol = curcol + 1
  DO heading
  IF (lines = lastlines)
    GO toprec
  ELSE
    toprec = saverec
  ENDIF
  DO paintscr
  GO saverec
  IF (lines <> lastlines)
    @ startrow,0 SAY ""
  ELSE
    @ saverow,0 SAY ""
  ENDIF
  DO highlite
ENDIF
RETURN

PROCEDURE key003                                    && PgDn

  PRIVATE saverow
  saverow = ROW()
  GO toprec
  SKIP (maxrows/lines - 1)
  DO paintscr
  SKIP (saverow-2)/lines
  IF (EOF())
    GO BOTTOM
  ENDIF
  DO highlite
  RETURN

PROCEDURE key004                                    && right arrow
DO key002                                           && make the same as
RETURN                                              && ctrl-right arrow


PROCEDURE key005                                    && up arrow
PRIVATE saverec,atfirst

saverec = RECNO()
SKIP -1
atfirst = BOF()
GO saverec
IF (atfirst)
  RETURN
ENDIF
IF (.NOT. BOF())
  IF (ROW() = startrow)
    SKIP -1
    DO paintscr
    DO highlite
  ELSE
*   @ ROW() - lines + 1,0 SAY ""
    @ ROW(),0 SAY ""
    DO paintlin
    SKIP -1
*   @ ROW() - (2*(INT(LEN(&displine)/maxcols))+1),0 SAY ""
    @ (ROW() - lines),0 SAY ""
*   @ ROW()-1,0 SAY ""
    DO highlite
  ENDIF
  RETURN
ENDIF

PROCEDURE key006                                    && End key
RETURN

PROCEDURE key013                                    && return key
DO edit
RETURN

PROCEDURE key018                                    && PgUp
PRIVATE saverow,saverec,atfirst
saverow = ROW()
saverec = RECNO()
GO toprec
SKIP -1
atfirst = BOF()
GO toprec
IF (.NOT. atfirst)
  SKIP -(maxrows/lines - 1)
  DO paintscr
* SKIP ((saverow - 1 - lines)/lines)
  SKIP ((saverow-lines)/lines) - 1 + (lines - 1)
  DO highlite
ELSE
  GO saverec
ENDIF
RETURN

PROCEDURE key019                                    && left arrow
DO key026                                           && make the same as
RETURN && ctrl-left arrow

PROCEDURE key024                                    && down arrow
PRIVATE saverec,atlast
saverec = RECNO()
SKIP
atlast = EOF()
GO saverec
IF (atlast)
  RETURN
ENDIF
IF ( (ROW() + lines - 1) >= maxrows - lines + 1)
  GO toprec
  SKIP 1
  DO paintscr
  GO saverec
  SKIP 1
* SKIP (INT(maxrows/lines)-1)
  @ ROW(),0 SAY ""
  DO highlite
ELSE
* @ ROW() - lines + 1,0 SAY ""
  @ ROW(),0 SAY ""
  DO paintlin
  SKIP
  @ ROW() + lines,0 SAY ""
  DO highlite
ENDIF
RETURN
PROCEDURE key026                                    && CTRL-left arrow
PRIVATE saverec,saverow

IF (curcol > 1)
  saverow = ROW()
  saverec = RECNO()
* GO toprec
  name = "COL" + SUBSTR(STR(curcol+1000-1,4),2)
  firstfield = &name
  curcol = curcol - 1
  DO heading
  IF (lines = lastlines)
    GO toprec
  ELSE
    toprec = saverec
  ENDIF
  DO paintscr
  GO saverec
  IF (lines <> lastlines)
    @ startrow,0 SAY ""
  ELSE
    @ saverow,0 SAY ""
  ENDIF
* @ saverow,0 SAY ""
  DO highlite
ENDIF
RETURN
PROCEDURE key030                                    && CTRL-PgDn
GO BOTTOM
DO paintscr
DO highlite
RETURN
PROCEDURE key031                                    && CTRL-PgUp
GO TOP
DO paintscr
@ startrow,0 SAY ""
DO highlite
RETURN

* These are here for expansion.
*PROCEDURE key028         && F1
*RETURN
*PROCEDURE key999         && F2
*RETURN
*PROCEDURE key998         && F3
*RETURN
*PROCEDURE key997         && F4
*RETURN
*PROCEDURE key996         && F5
*RETURN
*PROCEDURE key995         && F6
*RETURN
*PROCEDURE key994         && F7
*RETURN
*PROCEDURE key993         && F8
*RETURN
*PROCEDURE key992         && F9
*RETURN
*PROCEDURE key991         && f10
*RETURN

********************************************************************************
* PROCEDURE checkdbf:                                                          *
*                                                                              *
* This routine will ensure that a database is open.                            *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 30 SEP 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE checkdbf

IF (DBF() = "")
  ACCEPT "No database is in USE, enter filename: " to fn
  IF (TRIM(fn) = "")
    CANCEL
  ELSE
    USE &fn alias dbasebug
  ENDIF
ENDIF
RETURN

********************************************************************************
* PROCEDURE getndx:                                                            *
*                                                                              *
* This routine will prompt for an index file name.                             *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 15 OCT 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE getndx

IF (NDX(1) = "")
  ACCEPT "Enter the name of an index file (press <CR> for none) : " to fn
  IF (TRIM(fn) = "")
    RETURN
  ELSE
    SET INDEX TO &fn
  ENDIF
ENDIF
RETURN

********************************************************************************
* PROCEDURE stripfn:                                                           *
*                                                                              *
* This routine will remove the path and extension from a filename.             *
*                                                                              *
* AUTHOR: WordTech Late Night Crew                                             *
*                                                                              *
* 15 OCT 1987                                                                  *
* Copyright (C) 1987 WordTech Systems, Inc.  All Rights Reserved               *
********************************************************************************
PROCEDURE stripfn
PARAMETERS filename

IF (SUBSTR(filename,2,1) = ":")
  filename = SUBSTR(filename,3)
ENDIF
pos = AT("\",filename)
DO WHILE (pos <> 0)
  filename = SUBSTR(filename,pos+1)
  pos = AT("\",filename)
ENDDO
pos = AT(".",filename)
IF (pos <> 0)
  filename = SUBSTR(filename,1,pos-1)
ENDIF
RETURN
